#ifndef __AUTOMATON_H__
#define __AUTOMATON_H__

#define MAX_STRINGLEN 256

#define TAGTOLONG(a,b,c,d) ((unsigned long)(((a)<<24)|((b)<<16)|((c)<<8)|(d)))
#define TABLEMAGICNUMBER TAGTOLONG('M','D','I','C')

/* DAGElement = ULONG. */
/* Bits 0-7 de poids faible = Char */
/* Bit 8 = IsBase | NextFilled */
/* Bit 9 = IsFinal */
/* Bits 10-31 = NextBase */
typedef unsigned long DAGElement ;

#define CLEARELEM(foo) \
	((foo) = 0L)

#define GETCHAR(foo) \
	((unsigned char) ((foo) & 0xFF))

#define GETISBASE(foo) \
	((foo) & 0x00000100)

#define GETNEXTFILLED(foo) \
	((foo) & 0x00000100)

#define GETISFINAL(foo) \
	((foo) & 0x00000200)

#define GETNEXTBASE(foo) \
	((unsigned long) ((foo) >> 10))

#define SETCHAR(Foo,Char) \
	((Foo) &= 0xFFFFFF00) ; \
	((Foo) |= (Char))

#define SETISBASE(Foo) \
	((Foo) |= (1L << 8))

#define UNSETISBASE(Foo) \
	(Foo &= 0xFFFFFEFF)

#define SETNEXTFILLED(Foo) \
	((Foo) |= (1L << 8))

#define UNSETNEXTFILLED(Foo) \
	((Foo) &= 0xFFFFFEFF)

#define SETISFINAL(Foo) \
	((Foo) |= (1L << 9))

#define UNSETISFINAL(Foo) \
	((Foo) &= 0xFFFFFDFF)

#define SETNEXTBASE(Foo,BaseValue) \
	(Foo) &= 0x000003FF ; \
	(Foo) |= ((unsigned long) (BaseValue << 10))

/* VALEUR DU <<POINTEUR>> SIGNIFIANT TRANSITION NON EXISTANTE */
#define END_TRANSITION 0x3FFFFF

#endif
