#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "basicTypedefs.h"
#include "automaton.h"
#include "global.h"



BoolTy loadDictionaryFromRawData (unsigned long *rawData)
{
  if (rawData == NULL) return (FALSE) ;

  /* Check magic word. */
  if (rawData[0] != TABLEMAGICNUMBER) return (FALSE) ;

  /* Check automaton size. */
  automaton_size = rawData[1] ;
  if (automaton_size == 0) return (FALSE) ;

  /* Get the initial state. */
  initial_state = rawData[2] ;

  /* Allocate memory to store the dictionary words and assign the global
     pointer representing the automaton. */
  automaton = (DAGElement*) malloc (automaton_size * sizeof (DAGElement)) ;
  if (automaton == NULL) {
    /* Reset size and initial state. */
    automaton_size = 0 ;
    initial_state = END_TRANSITION ;
    return (FALSE) ;
  }

  /* Copy the raw data of the resource into our memory. */
  memcpy
    ((void*) automaton, (void*) &rawData[3],
     automaton_size * sizeof (DAGElement)) ;

  return (TRUE) ;
}



void unloadDictionary ()
{
  if (automaton != NULL) {
    free (automaton) ;
    automaton = NULL ;
  }
  automaton_size = 0 ;
  initial_state = END_TRANSITION ;
}
