#include <ctype.h>
#include <string.h>
#include "basicTypedefs.h"
#include "automaton.h"
#include "global.h"


/* Things made global to save stack during the recursion. */
unsigned char *word ;
size_t word_len ;



BoolTy recExists (unsigned long base, unsigned char index_word)
{
  unsigned int turn_flag, i ;
  unsigned char current_letter, tmp_char ;
  DAGElement bucket ;

  // Determine le nombre de tours qu'il faudra faire en fonction
  // de l'importance de la casse. Le premier tour est celui ou l'on
  // tient compte de la casse.
  if (case_sensitive) turn_flag = 1 ;
  else turn_flag = 2 ;

  for (i=0; i<turn_flag; i++) {
    // Determine en fonction du tour ou on est si on est dans le cas
    // ou la casse importe ou non. Le premier tour est celui ou l'on
    // tient compte de la casse.
    if (i == 0) current_letter = word[index_word] ;
    else {
      tmp_char = word[index_word] ;
      if (isupper ((int) tmp_char))
        current_letter = (unsigned char) tolower ((int) tmp_char) ;
      else current_letter = (unsigned char) toupper ((int) tmp_char) ;
      // Pour eviter de faire une recherche inutile si la lettre ne
      // fait pas de difference entre micusculee et majusculee
      if (current_letter == word[index_word]) break ;
    }

    // On vÈrifie que l'on ne sort pas du dictionnaire
    if ((base + current_letter) < automaton_size) {
      bucket = automaton[base + current_letter] ;
      tmp_char = GETCHAR (bucket) ;
      // On vÈrifie si la case est bien utilisÈe (inutile je pense en fait)
      if (tmp_char != '\0') {
        // On vÈrifie s'il existe une transition sur le caractËre du mot
        if (tmp_char == current_letter) {
          // Si on est ‡ la fin du mot il faut vÈrifier que Áa
          // correspond ‡ un mot rÈel du dictionnaire.
          if (index_word == (word_len - 1)) {
            // Si le mot correspond a un mot du dictionnaire, c'est bon
            if (GETISFINAL (bucket)) return (TRUE) ;
            // Sinon, on arrete et on passe eventuellement au tour suivant s'il en reste.
            else continue ;
          }
          // Sinon (si on n'est pas a la fin du mot), il faut continuer ‡ parcourir le mot
          else {
            if (recExists (GETNEXTBASE (bucket), index_word + 1))
              return (TRUE) ;
          }
        }           /* End of if (tmp_char == current_letter) */
      }             /* End of if (tmp_char != '\0') */
    }               /* End of if ((base + current_letter) < automaton_size) */
  }                 /* End of for (i=0; i<run_flag; i++) */
  return (FALSE) ;
}



BoolTy exists (unsigned char *searched_word)
{
  /* Just to make them global and save a bit a stack during recursion. */
  word = searched_word ;
  word_len = strlen ((char*) word) ;
  return (recExists (initial_state, 0)) ;
}
