//
//  FirstViewController.m
//  IDic
//
//  Created by Didou on 08/09/09.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//
#import "globalITouchData.h"
#import "FirstViewController.h"
#include "automaton.h"
#include "global.h"
#include "suggest.h"
#include "suggBasics.h"
#include "cheat.h"
#include "exist.h"


@implementation FirstViewController

/* Make sure that the File's Owner of the file "MainWindow.xib" belongs to the
 class FirstViewController. So, select the File's Owner, the tab identity in
 the inspector, then FirstViewController in the field class.
 This allows to connect the outlets when right-clicking on the File's Owner
 under Ibuilder. */
@synthesize requestField ;
@synthesize goButton ;
@synthesize suggestionsText ;
@synthesize modeSegControl ;
@synthesize dicFlagImgView ;
@synthesize searchActivityInd ;

/*
// The designated initializer. Override to perform setup that is required
// before the view is loaded.
- (id) initWithNibName: (NSString *) nibNameOrNil
                        bundle: (NSBundle *) nibBundleOrNil
{
  if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
  // Custom initialization
  }
  return (self) ;
}
*/



/*
// Implement loadView to create a view hierarchy programmatically, without
// using a nib.
- (void) loadView
{
}
*/



- (void) changeUsageMode :(id) sender
{
	switch ([sender selectedSegmentIndex]) {
    case 0: currentWorkingMode = WM_Spell ; break ;
    case 1: currentWorkingMode = WM_Check ; break ;
    case 2: currentWorkingMode = WM_Cheat ; break ;
	  /* default: Do nothing, simply silently ignore. */
	}
}



- (void) viewDidLoad
{
  [super viewDidLoad] ;
  [modeSegControl addTarget: self
	  action: @selector (changeUsageMode:)
		forControlEvents: UIControlEventValueChanged] ;
}



- (void) viewDidAppear: (BOOL) animated
{
  [super viewDidAppear: animated] ;
	/* Update the abbreviation indicating the currently used dictionary. */
	[self setDicFlag: availDictsFlags[currentDicNameIndex]] ;
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL) shouldAutorotateToInterfaceOrientation:
            (UIInterfaceOrientation) interfaceOrientation
{
  // Return YES for supported orientations
  return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/



- (void) didReceiveMemoryWarning
{
  /* Releases the view if it doesn't have a superview. */
  [super didReceiveMemoryWarning] ;
  /* Release any cached data, images, etc that aren't in use. */
}



- (void) viewDidUnload
{
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}



/* *************
   Kind: System.
   ************* */
- (void) dealloc
{
	[searchActivityInd release] ;
	[dicFlagImgView dealloc] ;
  [requestField dealloc] ;
  [goButton dealloc] ;
  [suggestionsText dealloc] ;
  [modeSegControl dealloc] ;
  [super dealloc] ;
}



/* ***************
   Kind: Exported
   *************** */
- (IBAction) goButtonClicked: (id) sender
{
	[requestField resignFirstResponder] ;
	[self submitRequest: requestField.text] ;
}



/* *******************
   Kind: Not exported.
   ******************* */
- (BOOL) textFieldShouldReturn: (UITextField *) aTextField
{
  /* When the user presses return, take focus away from the text field so that
     the keyboard is dismissed. */
  if (aTextField == requestField) {
    [aTextField resignFirstResponder] ;
    /* Invoke the method that performs the request according to the current
       working mode. */
    [self submitRequest: requestField.text] ;
  }
  /* Returns YES to say that the standard behaviour must be applied. */
  return (YES) ;
}


/*
- (void) startWheel: (NSTimer*) aTimer
{
  [searchActivityInd startAnimating] ;
}

searchActivityInd.hidden = NO ;
solvingTimer =
[[NSTimer
  scheduledTimerWithTimeInterval: 0.1 target: self
  selector: @selector (startWheel:) userInfo: nil repeats: NO]
 retain] ;
 ...
 [solvingTimer invalidate] ;
 [solvingTimer release] ;
 [searchActivityInd stopAnimating] ;
 searchActivityInd.hidden = YES ;
*/


/* *******************
   Kind: Not exported.
   ******************* */
- (void) submitRequest: (NSString*) requestString
{
  char txtAsBytes[MAX_STRINGLEN] ;
  NSString *suggestionsAsNSString ;
  
	/* Start animating the search activity indicator. */
	searchActivityInd.hidden = NO ;
	[searchActivityInd startAnimating] ;
  /* Recover the C-string from the NSString. */
  [requestField.text
     getCString:
       txtAsBytes maxLength: MAX_STRINGLEN
       encoding: NSISOLatin1StringEncoding] ;
  
	switch (currentWorkingMode) {
		case WM_Spell:
		case WM_Cheat:
			/* Trigger the computation of suggestions by calling the routine
				corresponding to the current working mode. We can factorise code
			  since spelling and cheating return a list of suggestions. For the
				verification of existence, since it returns a boolean, we must do
				it a bit differently. */
			if (currentWorkingMode == WM_Spell)
				suggest ((unsigned char*) txtAsBytes) ;
			else cheat ((unsigned char*) txtAsBytes) ;
			
			/* Recover the string representing all the catened suggesions. */
			char* suggestionsString = (char*) getStringFromSuggestions () ;
			if (suggestionsString != NULL) {
				/* Now, insert this big string into the suggestions UITextViex. */
				suggestionsAsNSString =
				[[NSString alloc] initWithBytes:
				 suggestionsString length: strlen (suggestionsString)
															 encoding: NSISOLatin1StringEncoding] ;
				suggestionsText.text = suggestionsAsNSString ;
				/* Release the memory used by the string representing all the catened
				 suggesions. */
				free (suggestionsString) ;
				[suggestionsAsNSString release] ;
			}              /* End of if (suggestionsString != NULL). */
			else {
				/* Just display a message to say there is nothing found. */
				suggestionsText.text =
          NSLocalizedString (@"strNoMatchFound", @"Search gave no suggestion") ;
			}
			/* Free the memory used by the chained list fo suggestions. */
			releaseSuggestions () ;
			break ;
			
		case WM_Check:
			/* Not yet implemented. */
      if (exists ((unsigned char*) txtAsBytes))
        suggestionsText.text =
          NSLocalizedString (@"strWordExists", @"Word exists") ;
      else
        suggestionsText.text =
          NSLocalizedString (@"strWordNotExists", @"Word doesn't exist") ;
			break ;
	}

	[searchActivityInd stopAnimating] ;
	searchActivityInd.hidden = YES ;
}



- (void) setDicFlag: (NSString*) flagName
{
  UIImage *img = dicFlagImgView.image ;

  NSString *flagPath =
		[[NSBundle mainBundle] pathForResource: flagName ofType: @"png"] ;
	img = [UIImage imageWithContentsOfFile: flagPath] ;
	[dicFlagImgView setImage: img] ;
}

@end
